<?php

/**
 * @file
 * @author Themler.io
 * Contains \Drupal\themler\Controller\ThemlerController.
 * Please place this file under your themler(module_root_folder)/src/Controller/
 */
namespace Drupal\themler\Controller;

use Drupal\Core\Controller\ControllerBase;

require_once(dirname(__FILE__).'/../actions.php');


/**
 * Provides route responses for the Themler module.
 */
class ThemlerController extends ControllerBase {

    public function process_request($action) {
        return themler_process_request($action);
    }

    /**
      * Returns Themler page.
      *
      * @return
      */
    public function page() {
        themler_init();
        $theme_name = getValue('theme');
        $username = getValue('username');
        $passwd = getValue('passwd');
        $query = themler_get_params();
        $url = '';

        if (user_is_logged_in()) {        
            if ($theme_name) { // removed check $username || $passwd for autologin
                check_permissions($theme_name);
                $project = get_project(get_theme_dir($theme_name));
                $php_version = phpversion();
                $required_php_version = '5.5.3';

                if (!count((array)$project)) {
                    drupal_set_message(sprintf('The theme `%s` cannot be opened because /project/project.json file is missing or corrupted.', $theme_name), 'error');
                    $url = 'system.themes_page';
                } elseif ($php_version && version_compare($php_version, $required_php_version, '<')) {
                    drupal_set_message(sprintf('Unable to open theme. Your server is running php version %s but Themler requires %s or higher. Please upgrade PHP version to continue.', $php_version,  $required_php_version), 'error');
                    $url = 'system.themes_page';
                } else {
                    echo themler_show($theme_name);
                }
            } else {
                drupal_set_message('Themler: wrong theme name parameter', 'error');
                $url = 'system.themes_page';
            }
        }
        else {
            if ($theme_name && $username && $passwd && ($uid = \Drupal::service('user.auth')->authenticate($username, $passwd))) {
                $account = \Drupal::entityManager()->getStorage('user')->load($uid);
                user_login_finalize($account);
                $url = 'themler.show'; // TODO: autologin! without username and password shown. use $url instead
                //echo themler_show($theme_name); 
            } else {
                drupal_set_message('Access denied: please login first', 'error');
                $url = 'user.login';
                $query = array('destination' => \Drupal::request()->getRequestUri());
            }
        }
        // TODO: check manifest adding after export & update
        themler_add_manifest_version($theme_name, $query);
        if (!empty($url)) {
            return $this->redirect($url, $query);
        }
        die;
  }
}
?>