<?php

/**
 * @file
 * Contains \Drupal\themler\Theme\PreviewNegotiator.
 */

namespace Drupal\themler\Theme;

use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Theme\ThemeNegotiatorInterface;

/**
 * Negotiates the preview theme for Themler.
 */
class PreviewNegotiator implements ThemeNegotiatorInterface {

  /**
   * {@inheritdoc}
   */
  public function applies(RouteMatchInterface $route_match) {
    return getValue('theme');
  }

  /**
   * {@inheritdoc}
   */
  public function determineActiveTheme(RouteMatchInterface $route_match) {
    return get_preview_theme_name(getValue('theme'));
  }

}