<?php

class PermissionsException extends Exception
{
    public function __construct($message, $code = 0, Exception $previous = null) {
        $folders = get_premission_dirs();
        $base_url = get_base_url_with_slash();
        $content = file_get_contents(dirname(__FILE__).'/warning.php');
        $content = preg_replace('/[\r\n]/', '', $content);
        $content = str_replace('{folders}', implode("<br/>", $folders), $content);
        $content = str_replace('{root}', $base_url, $content);
        $message = $this->getMessage() . ' ' . $message . "\n" . $content;
        ob_start();
        if (defined('DEBUG_BACKTRACE_IGNORE_ARGS')) {
            debug_print_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
        } else {
            debug_print_backtrace();
        }
        $message .= '<!--' . ob_get_clean() . '-->';
        parent::__construct($message, $code, $previous);
    }
}